// CELIBRD.CPP
//
// CE̕iCu̓ǂݍ

#include "stdafx.h"
#include <assert.h>
#include "LCo.h"

#include "PartInfo.h"
#include "LCoData.h"
#include "CeLib.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char g_szLibraryID[]="LIB FOR CE000\x1a";


//sԍ(DWORD)𕶎ɕϊ
//Ԓl sԍ\    TRUE
//Ԓl sԍ\  FALSE
BOOL g_dwPinToszPin(DWORD dwPin,char* pszPin)
{
	BOOL bResult=((dwPin & 0x8000)==0);
	if(dwPin & 0x7C00)	*pszPin++=(char)((((dwPin & 0x7C00)>>10)+'A'-1)&0x7F);
	_itoa(dwPin & 0x1FF,pszPin,10);
	return bResult;
}




////////////////////////////////////////////////////////////
// s|b
static void PinName2Cstr(char *pstr,char *cstr)
{
	int i,n;
	
	n=*pstr++;
	for(i=0;i<n;i++){
		if(*pstr & 0x80){
			*cstr++='\\';
			*cstr=(*pstr)&0x7F;
			cstr++;pstr++;
		}else{
			*cstr++ = *pstr++;
		}
	*cstr=0;
	}
}




////////////////////////////////////////////////////////////////////
// CE2Cũp^[LCõp^[쐬
// PCoCgPʁ[hPʂւ̕ϊ
static CLCoPtn* s_CE2PtnToLCoPtn(BYTE* pCE2Ptn)
{
	int nCE2Xbyte,nBitmapXbyte;			//X̃oCg
	BYTE *pSrc,*pDst,*pSrcTop,*pDstTop;	//Rs[Ɏg|C^

	if(!pCE2Ptn) return NULL;

	CLCoPtn* pLCoPtn=new CLCoPtn;

	pLCoPtn->m_size.cx=*((short*)(pCE2Ptn));
	pLCoPtn->m_size.cy=*((short*)(pCE2Ptn+2));
	nCE2Xbyte=(pLCoPtn->m_size.cx+7)/8;
	nBitmapXbyte=((pLCoPtn->m_size.cx+15)/16)*2;
	pLCoPtn->m_pBuff=new BYTE[nBitmapXbyte*pLCoPtn->m_size.cy];
	pSrcTop=pCE2Ptn+4;
	pDstTop=pLCoPtn->m_pBuff;
	int x,y;
	for(y=0;y<pLCoPtn->m_size.cy;y++){
		pSrc=pSrcTop;
		pDst=pDstTop;
		for(x=0;x<nCE2Xbyte;x++) *pDst++=*pSrc++;
		pSrcTop+=nCE2Xbyte;
		pDstTop+=nBitmapXbyte;
	}
  	return pLCoPtn;
}


////////////////////////////////////////////////////////////////////
// CE2Cũs LCo`̃s쐬
static CLCoPin* s_CE2PinToLCoPin(int nBlock,CE2PinInfo* pCE2Pin)
{
	if(!pCE2Pin) return NULL;
	CLCoPin* pPin=new CLCoPin;
	pPin->m_pstrPinNum=new CString[nBlock];
	int i;
	char sz[16];
	CString strHFlag;
	for(i=0;i<nBlock;i++){ 
	//		pPin->m_pdwNum[i]=pCE2Pin->arywNum[i];
		if(g_dwPinToszPin(pCE2Pin->arywNum[i],sz)){
			strHFlag="D";
		}else{
			strHFlag="H";
		}
		pPin->m_pstrPinNum[i]=strHFlag+sz;
	}

	if(pCE2Pin->wStatus & 0x1000) pPin->m_nType |= PIN_TYPE_SMALL;
	if(pCE2Pin->wStatus & 0x4000) pPin->m_nType |= PIN_TYPE_CLOCK;
	if(pCE2Pin->wStatus & 0x8000) pPin->m_nType |= PIN_TYPE_NEGATIVE;
	pPin->m_nOffset =  pCE2Pin->wStatus & 0xFF;
	pPin->m_nLTRB   =((pCE2Pin->wStatus)>>8 )& 0x3;
	return pPin;
}


//p^[̃rbg}bv̓ǂݍ
unsigned char* CLCoData::ReadLb3Bmp(SReadCE3& rce3,int x,int y)
{
	assert(x>0 && y>0);
	string str;
	int buffXByte = ((x+15)/16)*2;
	int xByte = (x+7)/8;
	int nBuffSize=buffXByte * y;
	unsigned char* buff= (unsigned char*)new char[nBuffSize];
	unsigned char* pw = buff;
	while(nBuffSize){
		*pw++=0;
		nBuffSize--;
	}
	int yCount=0;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '-'){
			if(str=="-BMP") return buff; 
			else goto RdErr;
		}else if(str[0] == '+'){
			str[0]='-';
			if(rce3.SkipTo(str) == EOF) goto RdErr;
		}else if(yCount<y){
			pw=buff+ yCount * buffXByte;
			int nMax=str.length()/2;
			if(nMax > xByte) nMax = xByte;
			int m=0;
			int n;
			for(n=0;n<nMax;n++){
				int uppr = str[m++] - '@';
				int lowr = str[m++] - '@';
				if(uppr>=0 && uppr<=15 && lowr>=0 && lowr<=15){
					pw[n]=(uppr<<4)+ lowr;
				}else{
					pw[n]=0;
				}
			}
			yCount++;
		}
	}
RdErr:
	delete[]buff;
	return NULL;
}
		

//p^[̓ǂݍ
BOOL CLCoData::ReadLb3Ptn(SReadCE3& rce3)
{
	string name("");
	int x=0;
	int y=0;
	unsigned char* ptnBuff=NULL;
	CLCoPtn* pPtn=NULL;

	string str;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '-'){
			if( (str != "-PTN") || ptnBuff==NULL ){
				goto RdErr;
			}else{
				break;
			}
		}else if(str[0] == '+'){
			if(str=="+BMP" && x>0 && y>0 && name!="" && ptnBuff==NULL){
				if(NULL==(ptnBuff=ReadLb3Bmp(rce3,x,y))) goto RdErr;
			}else{
				str[0]='-';
				if(rce3.SkipTo(str) == EOF) goto RdErr;
			}
		}else{
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<(l-1)){	// : ŕꂽR[hł
				string var = str.substr(0,n);				//擪:̎O܂
				//int nParam = atoi(str.substr(n+1).c_str()); //:I[܂ł𐔒lɕϊ
				if(var=="X"){
					x = atoi(str.substr(n+1).c_str()); //:I[܂ł𐔒lɕϊ
				}else
				if(var=="Y"){
					y = atoi(str.substr(n+1).c_str()); //:I[܂ł𐔒lɕϊ
				}else
				if(var=="N"){
					name = str.substr(n+1).c_str();
				}
			}
		}
	}
	pPtn = new CLCoPtn;
	pPtn->m_size.cx = x;
	pPtn->m_size.cy = y;
	pPtn->m_strName = name.c_str();
	pPtn->m_pBuff = ptnBuff;
	m_listPtn.AddTail(pPtn);
	return TRUE;
RdErr:
	delete[]ptnBuff;
	return FALSE;
}

CLCoPin* CLCoData::ReadLb3Pin(SReadCE3& rce3,int b)
{
	CLCoPin* pPin = new CLCoPin;
	pPin->m_pstrPinNum = new CString[b];
	BOOL pinNumHide=FALSE;
	int nPinSetCount=0;

	//+PIN,N:,L:L1,T:S,M:3,M:5,-PIN

	string str;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '-'){
			if(str != "-PIN"){
				goto RdErr;
			}else{
				break;
			}
		}else if(str[0] == '+'){
			str[0]='-';
			if(rce3.SkipTo(str) == EOF) goto RdErr;
		}else{
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<(l-1)){	// : ŕꂽR[hł
				string var = str.substr(0,n);				//擪:̎O܂
				if(var=="N"){
					pPin->m_strName = str.substr(n+1).c_str();
				}else if(var=="L"){
					switch ((str.substr(n+1))[0]){
					case 'L': pPin->m_nLTRB = 0; break;
					case 'T': pPin->m_nLTRB = 1; break;
					case 'R': pPin->m_nLTRB = 2; break;
					case 'B': 
					default	: pPin->m_nLTRB = 3;
					}
					int nOffset = atoi(str.substr(n+2).c_str());
					if(nOffset>=0 && nOffset<=255){
						pPin->m_nOffset = nOffset;
					}
				}else if(var=="T"){
					int i=0;
					int len=str.substr(n+1).length();
					for(i=0;i<len;i++){
						switch ((str.substr(n+1))[i]){
						case 'S': pPin->m_nType |=  PIN_TYPE_SMALL;		break;
						case 'N': pPin->m_nType |=  PIN_TYPE_NEGATIVE;	break;
						case 'C': pPin->m_nType |=  PIN_TYPE_CLOCK;		break;
						case 'm': pinNumHide=TRUE;						break;
						}
					}
				}else if(var=="M"){
					if(nPinSetCount<b){
						if(pinNumHide)  pPin->m_pstrPinNum[nPinSetCount]="H";
						else			pPin->m_pstrPinNum[nPinSetCount]="D";
						pPin->m_pstrPinNum[nPinSetCount]+=str.substr(n+1).c_str();
						nPinSetCount++;
					}
				}
			}	
		}
	}
	return pPin;
RdErr:
	delete pPin;
	return NULL;
}



/*
N:LM324
X:4,Y:4,B:4
R:U
P:OPAMP
*/

BOOL CLCoData::ReadLb3Part(SReadCE3& rce3)
{
	string name("");
	string ref("U");
	string ptn("");
	int x=0;
	int y=0;
	int b=0;

	CLCoPartInfo* pPart = new CLCoPartInfo;
	CLCoPin* pPin;
	CLCoPtn* pPtn;
	CLCoPartIndex* pIndex;

	string str;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '-'){
			if(str != "-COMP" || name=="" || x<=0 || y<=0 || b<=0){
				goto RdErr;
			}else{
				break;
			}
		}else if(str[0] == '+'){
			if(str=="+PIN"){
				if(x<=0 || y<=0 || b<=0) goto RdErr; 
				if((pPin=ReadLb3Pin(rce3,b))==NULL) goto RdErr;
				pPart->m_listPin.AddTail(pPin);
			}else{
				str[0]='-';
				if(rce3.SkipTo(str) == EOF) goto RdErr;
			}
		}else{
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<l){	// : ŕꂽR[hł
				string var = str.substr(0,n);				//擪:̎O܂
				if(var=="N"){
					name=str.substr(n+1);
				}else if(var=="X"){
					x=atoi(str.substr(n+1).c_str());
					if(x<0) goto RdErr;
				}else if(var=="Y"){
					y=atoi(str.substr(n+1).c_str());
					if(y<0) goto RdErr;
				}else if(var=="B"){
					if(b!=0) goto RdErr;
					b=atoi(str.substr(n+1).c_str());
					if(b<0 || b>256) goto RdErr;
				}else if(var=="R"){
					ref=str.substr(n+1);
				}else if(var=="P"){
					ptn=str.substr(n+1);
				}
			}
		}
	}

	pPart->m_pPtn = NULL;
	if(ptn!=""){	//p^[ݒ肸݂Ȃp^[ւ̃|C^B
		POSITION pos=m_listPtn.GetHeadPosition();
		while(pos){
			pPtn = m_listPtn.GetNext(pos);
			if(pPtn->m_strName == ptn.c_str()){
				pPart->m_pPtn = pPtn;
				break;
			}
		}
	}
	pPart->m_size.cx =x;
	pPart->m_size.cy =y;
	pPart->m_nBlock  =b;
	pPart->m_strPrefix =ref.c_str();
	pIndex = new CLCoPartIndex;
	pIndex->m_strName = name.c_str();
	pIndex->m_pPartInfo = pPart;
	m_listPartIndex.AddTail(pIndex);
	m_listPartInfo.AddTail(pPart);
	return TRUE;
RdErr:
	delete pPart;
	return FALSE;
}


BOOL CLCoData::ReadLb3Alias(SReadCE3& rce3)
{
	string name("");
	string alias("");
	CLCoPartIndex* pIndexNew;
	CLCoPartIndex* pIndex;
	POSITION pos;

	string str;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '-'){
			if(str != "-ALIAS" || name=="" || alias==""){
				goto RdErr;
			}else{
				break;
			}
		}else if(str[0] == '+'){
			str[0]='-';
			if(rce3.SkipTo(str) == EOF) goto RdErr;
		}else{
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<(l-1)){	// : ŕꂽR[hł
				string var = str.substr(0,n);				//擪:̎O܂
				if(var=="N"){
					name=str.substr(n+1);
				}else if(var=="A"){
					alias=str.substr(n+1);
				}
			}
		}
	}
	pos = m_listPartIndex.GetHeadPosition();
	while(pos){
		pIndex = m_listPartIndex.GetNext(pos);
		if(pIndex->m_strName == name.c_str()){
			pIndexNew = new CLCoPartIndex;
			pIndexNew->m_strName = alias.c_str();
			pIndexNew->m_pPartInfo = pIndex->m_pPartInfo;
			m_listPartIndex.AddTail(pIndexNew);
			break;
		}
	}
	return TRUE;
RdErr:
	return FALSE;
}



//LB3Cu̓ǂݍ
BOOL CLCoData::ReadLb3(LPCSTR pszFilename)
{
	// f[^̃NA
	ClearAll();
	SReadCE3 rce3;
	string str;
	FILE* fp=fopen(pszFilename,"r");
	if(fp==NULL) goto RdErr;
	rce3.Attach(fp);
	if(rce3.ReadRecord(str)==EOF) goto RdErr;
	if(str != "+BSCH3_LIB_V.1.0") goto RdErr;
	while(rce3.ReadRecord(str)!=EOF){
		if(str[0] == '+'){
			if(str == "+PTN"){
				//TRACE("BOOL CLCoData::ReadLb3(LPCSTR pszFilename) +PTN\n");
				if(!ReadLb3Ptn(rce3)) goto RdErr;
			}else
			if(str == "+COMP"){
				//TRACE("BOOL CLCoData::ReadLb3(LPCSTR pszFilename) +COMP\n");
				if(!ReadLb3Part(rce3)) goto RdErr;
			}else
			if(str == "+ALIAS"){
				//TRACE("BOOL CLCoData::ReadLb3(LPCSTR pszFilename) +ALIAS\n");
				if(!ReadLb3Alias(rce3)) goto RdErr;
			}else{
				str[0]='-';
				if(rce3.SkipTo(str)==EOF) goto RdErr;
			}
		}
	}
	fclose(fp);
	return TRUE;
RdErr:
	fclose(fp);
	return FALSE;
}

/*
//CECu̓ǂݍ
BOOL CLCoData::ReadCeLibrary(LPCSTR pszFilename)
{
	

	BOOL bResult=FALSE;
	int nOffset;
	UINT nFileSize;
	int nPartLib;
	int nPtnLib;

	BYTE* pFileBuff;
	DWORD* pdwNameIndex;	//iCfbNX
	WORD*  pwPartIndex;		//iCfbNX
	BYTE*  pPartArea;		//i`GA
	WORD*  pwPtnIndex;		//p^[CfbNX
	WORD*  pwPtnNameIndex;	//p^[CfbNX
	BYTE*  pPtnArea;		//p^[GA
	char*  pTextArea;		//eLXgGA

	// f[^̃NA
	ClearAll();
	
	// t@CTCY𓾂ĈCǂ
	nFileSize=pFile->GetLength();
	if(nFileSize==0)									return TRUE;
	if(nFileSize<54)									return FALSE;
	pFileBuff=new BYTE[nFileSize];
	if(!pFileBuff) return FALSE;
	if(nFileSize!=pFile->Read(pFileBuff,nFileSize))		goto ENDOFFUNC;
	
	// wb_[̊mF
	pFileBuff[14]=0;	//lstrcmp̂߂ɏI[Zbg
	if(lstrcmp(g_szLibraryID,(LPCSTR)pFileBuff)!=0)		goto ENDOFFUNC;
	
	// Ǘi̎擾
	nPartLib=*((short*)(pFileBuff+16));
	if(nPartLib==0){ bResult=TRUE;						goto ENDOFFUNC;}

	//iCfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+18));
	pdwNameIndex	=(DWORD*)(pFileBuff+nOffset);
	//iCfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+22));
	pwPartIndex	=(WORD*)(pFileBuff+nOffset);
	//i`GA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+26));
	pPartArea	=(BYTE*)(pFileBuff+nOffset);	
	//p^[CfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+30));
	pwPtnIndex	=(WORD*)(pFileBuff+nOffset);
	//p^[CfbNXAhX̐ݒ
	nPtnLib=( *((int*)(pFileBuff+34)) - nOffset )/8;
	pwPtnNameIndex=pwPtnIndex+nPtnLib*3;
	//p^[GA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+34));
	pPtnArea=pFileBuff+nOffset;	
	//eLXgGA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+38));
	pTextArea=(char*)(pFileBuff+nOffset);


	//p^[̓o^s
	int nPtn;
	for(nPtn=0;nPtn<nPtnLib;nPtn++){
		CLCoPtn* pLCoPtn=s_CE2PtnToLCoPtn((BYTE*)(pPtnArea+pwPtnIndex[nPtn *3]));
		if(!pLCoPtn)											goto ENDOFFUNC;
		pLCoPtn->m_strName=CString(pTextArea+pwPtnNameIndex[nPtn]);
		m_listPtn.AddTail(pLCoPtn);
	}
	
	//i̐o^s
	int nPart;
	for(nPart=0;nPart<nPartLib;nPart++){
		CLCoPartIndex* pIndex=new CLCoPartIndex;
		pIndex->m_strName=CString(pTextArea+pdwNameIndex[nPart]);
		WORD  wPartIndex=pwPartIndex[nPart];
		//GCAX
		{
			int i;
			for(i=0;i<nPart;i++)
			{
				if(wPartIndex==pwPartIndex[i])
				{//iԖڂɓo^ς݂̕iGCAX
					POSITION pos;
					pos=m_listPartIndex.FindIndex(i);
					if(!pos){
						TRACE(" CLCoData::ReadCeLibrary() Invalid pos\n");
						return FALSE;
					}
					CLCoPartIndex* pIndexAlias=m_listPartIndex.GetAt(pos);
					pIndex->m_pPartInfo=pIndexAlias->m_pPartInfo;
					m_listPartIndex.AddTail(pIndex);
					break;
				}
			}
			if(pIndex->m_pPartInfo!=NULL) continue;
			//pIndex->m_pPartInfoNULLłȂ΃GCAXƂēo^Ă
		}
		CLCoPartInfo* pPartInfo=new CLCoPartInfo;
		CE2PartInfo* pCE2PartInfo=(CE2PartInfo*)(pPartArea+wPartIndex);

		pPartInfo->m_size.cx=pCE2PartInfo->bX;
		pPartInfo->m_size.cy=pCE2PartInfo->bY;
		pPartInfo->m_nBlock =pCE2PartInfo->bDev;
		pPartInfo->m_strPrefix=CString((char*)(pTextArea+pCE2PartInfo->wPrefix));
		if(pCE2PartInfo->wPtn!=0xFFFF)
		{//p^[gĂꍇ́Am_listPtnɓo^ς݂̃p^[̃|C^𓾂
			POSITION pos;
			pos=m_listPtn.FindIndex(pCE2PartInfo->wPtn);
			if(!pos){
				TRACE("CLCoData::ReadCeLibrary() Invalid pos\n");
				return FALSE;
			}
			pPartInfo->m_pPtn=m_listPtn.GetAt(pos);
		}	

		int nPin=pCE2PartInfo->wPinInfo & 0xFFF;//s
		int nCE2PinRecSize=4+2*pPartInfo->m_nBlock;	//CE2̃Cũs̈̃TCY
		CE2PinInfo* pCE2PinInfo=(CE2PinInfo*) (((WORD*)(&(pCE2PartInfo->wPinInfo)))+1);
		for(int i=0;i<nPin;i++)
		{
			CLCoPin* pPin=s_CE2PinToLCoPin(pPartInfo->m_nBlock,pCE2PinInfo);
			if(pCE2PinInfo->wName!=0xFFFF)
			{
				char sz[128];
				char* pName=pTextArea+pCE2PinInfo->wName;
				PinName2Cstr(pName,sz);
				pPin->m_strName=CString(sz);
			}//pPin->m_strName͉o^Ȃ΋̕
			pPartInfo->m_listPin.AddTail(pPin);
			pCE2PinInfo=(CE2PinInfo*)( ((BYTE*)pCE2PinInfo)+nCE2PinRecSize );
		}
		m_listPartInfo.AddTail(pPartInfo);
		pIndex->m_pPartInfo=pPartInfo;
		m_listPartIndex.AddTail(pIndex);
	}

	bResult=TRUE;
ENDOFFUNC:
	delete[]pFileBuff;
	if(!bResult) ClearAll();
	return bResult;
}

*/


//CECu̓ǂݍ
BOOL CLCoData::ReadCeLibrary(LPCSTR pszFilename)
{
	CFile file;
	if(!file.Open(pszFilename,CFile::modeRead)) return FALSE;

	BOOL bResult=FALSE;
	int nOffset;
	UINT nFileSize;
	int nPartLib;
	int nPtnLib;

	BYTE* pFileBuff;
	DWORD* pdwNameIndex;	//iCfbNX
	WORD*  pwPartIndex;		//iCfbNX
	BYTE*  pPartArea;		//i`GA
	WORD*  pwPtnIndex;		//p^[CfbNX
	WORD*  pwPtnNameIndex;	//p^[CfbNX
	BYTE*  pPtnArea;		//p^[GA
	char*  pTextArea;		//eLXgGA

	// f[^̃NA
	ClearAll();
	
	// t@CTCY𓾂ĈCǂ
	nFileSize=file.GetLength();
	if(nFileSize==0)									return TRUE;
	if(nFileSize<54)									return FALSE;
	pFileBuff=new BYTE[nFileSize];
	if(!pFileBuff) return FALSE;
	if(nFileSize!=file.Read(pFileBuff,nFileSize))		goto ENDOFFUNC;
	
	// wb_[̊mF
	pFileBuff[14]=0;	//lstrcmp̂߂ɏI[Zbg
	if(lstrcmp(g_szLibraryID,(LPCSTR)pFileBuff)!=0)		goto ENDOFFUNC;
	
	// Ǘi̎擾
	nPartLib=*((short*)(pFileBuff+16));
	if(nPartLib==0){ bResult=TRUE;						goto ENDOFFUNC;}

	//iCfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+18));
	pdwNameIndex	=(DWORD*)(pFileBuff+nOffset);
	//iCfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+22));
	pwPartIndex	=(WORD*)(pFileBuff+nOffset);
	//i`GA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+26));
	pPartArea	=(BYTE*)(pFileBuff+nOffset);	
	//p^[CfbNX̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+30));
	pwPtnIndex	=(WORD*)(pFileBuff+nOffset);
	//p^[CfbNXAhX̐ݒ
	nPtnLib=( *((int*)(pFileBuff+34)) - nOffset )/8;
	pwPtnNameIndex=pwPtnIndex+nPtnLib*3;
	//p^[GA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+34));
	pPtnArea=pFileBuff+nOffset;	
	//eLXgGA̐擪AhX̐ݒ
	nOffset=*((int*)(pFileBuff+38));
	pTextArea=(char*)(pFileBuff+nOffset);


	//p^[̓o^s
	int nPtn;
	for(nPtn=0;nPtn<nPtnLib;nPtn++){
		CLCoPtn* pLCoPtn=s_CE2PtnToLCoPtn((BYTE*)(pPtnArea+pwPtnIndex[nPtn *3]));
		if(!pLCoPtn)											goto ENDOFFUNC;
		pLCoPtn->m_strName=CString(pTextArea+pwPtnNameIndex[nPtn]);
		m_listPtn.AddTail(pLCoPtn);
	}
	
	//i̐o^s
	int nPart;
	for(nPart=0;nPart<nPartLib;nPart++){
		CLCoPartIndex* pIndex=new CLCoPartIndex;
		pIndex->m_strName=CString(pTextArea+pdwNameIndex[nPart]);
		WORD  wPartIndex=pwPartIndex[nPart];
		//GCAX
		{
			int i;
			for(i=0;i<nPart;i++)
			{
				if(wPartIndex==pwPartIndex[i])
				{//iԖڂɓo^ς݂̕iGCAX
					POSITION pos;
					pos=m_listPartIndex.FindIndex(i);
					if(!pos){
						TRACE(" CLCoData::ReadCeLibrary() Invalid pos\n");
						return FALSE;
					}
					CLCoPartIndex* pIndexAlias=m_listPartIndex.GetAt(pos);
					pIndex->m_pPartInfo=pIndexAlias->m_pPartInfo;
					m_listPartIndex.AddTail(pIndex);
					break;
				}
			}
			if(pIndex->m_pPartInfo!=NULL) continue;
			//pIndex->m_pPartInfoNULLłȂ΃GCAXƂēo^Ă
		}
		CLCoPartInfo* pPartInfo=new CLCoPartInfo;
		CE2PartInfo* pCE2PartInfo=(CE2PartInfo*)(pPartArea+wPartIndex);

		pPartInfo->m_size.cx=pCE2PartInfo->bX;
		pPartInfo->m_size.cy=pCE2PartInfo->bY;
		pPartInfo->m_nBlock =pCE2PartInfo->bDev;
		pPartInfo->m_strPrefix=CString((char*)(pTextArea+pCE2PartInfo->wPrefix));
		if(pCE2PartInfo->wPtn!=0xFFFF)
		{//p^[gĂꍇ́Am_listPtnɓo^ς݂̃p^[̃|C^𓾂
			POSITION pos;
			pos=m_listPtn.FindIndex(pCE2PartInfo->wPtn);
			if(!pos){
				TRACE("CLCoData::ReadCeLibrary() Invalid pos\n");
				return FALSE;
			}
			pPartInfo->m_pPtn=m_listPtn.GetAt(pos);
		}	

		int nPin=pCE2PartInfo->wPinInfo & 0xFFF;//s
		int nCE2PinRecSize=4+2*pPartInfo->m_nBlock;	//CE2̃Cũs̈̃TCY
		CE2PinInfo* pCE2PinInfo=(CE2PinInfo*) (((WORD*)(&(pCE2PartInfo->wPinInfo)))+1);
		for(int i=0;i<nPin;i++)
		{
			CLCoPin* pPin=s_CE2PinToLCoPin(pPartInfo->m_nBlock,pCE2PinInfo);
			if(pCE2PinInfo->wName!=0xFFFF)
			{
				char sz[128];
				char* pName=pTextArea+pCE2PinInfo->wName;
				PinName2Cstr(pName,sz);
				pPin->m_strName=CString(sz);
			}//pPin->m_strName͉o^Ȃ΋̕
			pPartInfo->m_listPin.AddTail(/*(void*)*/pPin);
			pCE2PinInfo=(CE2PinInfo*)( ((BYTE*)pCE2PinInfo)+nCE2PinRecSize );
		}
		m_listPartInfo.AddTail(pPartInfo);
		pIndex->m_pPartInfo=pPartInfo;
		m_listPartIndex.AddTail(pIndex);
	}

	bResult=TRUE;
ENDOFFUNC:
	delete[]pFileBuff;
	if(!bResult) ClearAll();
	return bResult;
}

