#ifndef LCODATA_H
#define LCODATA_H

#include "ce3io.h"

class CLCoData
{
public:
	CTypedPtrList<CPtrList, CLCoPtn*>		m_listPtn;			//p^[̃Xg
	CTypedPtrList<CPtrList, CLCoPartInfo*>	m_listPartInfo;		//ĩXg
	CTypedPtrList<CPtrList, CLCoPartIndex*>	m_listPartIndex;	//iCfbNX̃Xg
	CString m_strDataTitle;
	CString m_strDataPath;

	BOOL m_bDirty;						//㖢ۑ
	BOOL m_bSetPath;					//t@CftHgύX

	CLCoData()
	{
		ClearAll();
	}

	virtual ~CLCoData()
	{
		ClearAll();
	}

	void ClearAll();					//f[^SăNA 

	unsigned char* ReadLb3Bmp(SReadCE3& rce3,int x,int y); //p^[̃rbg}bv̓ǂݍ
	BOOL ReadLb3Ptn(SReadCE3& rce3);
	CLCoPin* ReadLb3Pin(SReadCE3& rce3,int b);
	BOOL ReadLb3Part(SReadCE3& rce3);
	BOOL ReadLb3Alias(SReadCE3& rce3);
	BOOL ReadLb3(LPCSTR pszFilename);			//LB3Cu̓ǂݍ
	BOOL ReadCeLibrary(LPCSTR pszFilename);
//	BOOL ReadCeLibrary(CFile* pFile);		//CECu̓ǂݍ
//	BOOL WriteCeLibrary(CFile* pFile);	//CECȕ
	BOOL WriteCeLibrary(LPCSTR pszFilename);	//CECȕ
	
	BOOL WriteLb3Ptn(SWriteCE3& wce3,const CLCoPtn* pPtn);
	BOOL WriteLb3PinInfo(SWriteCE3& wce3,const CLCoPin* pPin,int nBlock);
	BOOL WriteLb3PartInfo(SWriteCE3& wce3,const CLCoPartInfo* pPartInfo);
	BOOL WriteLb3(LPCSTR pszFilename);	//LB3Cȕ

	BOOL SetPtn();						//CECȕݎ̃p^[ꊇݒ
	int  GetPtnIndex(CLCoPtn* pPtn);	//p^[̃CfbNX𓾂
	BOOL SetPartArea();					//iGAւ̕ĩZbg
	BOOL SetPartIndex();				//iijCfbNX̃Zbg
};

#endif

