// LCoDlg.h : wb_[ t@C
//

/////////////////////////////////////////////////////////////////////////////
// CLCoDlg dialog

class CLCoDlg : public CDialog
{
	enum PINTYPE_RADIO{
		PINTYPE_RADIO_NULLPIN,
		PINTYPE_RADIO_NORMPIN,
		PINTYPE_RADIO_CKPIN,
		PINTYPE_RADIO_NEGPIN,
		PINTYPE_RADIO_NEGCKPIN,
		PINTYPE_RADIO_SPIN
	};



// \z
public:
	CLCoDlg(CWnd* pParent = NULL);	// W̃RXgN^
	HACCEL m_hAccel;

// Dialog Data
	//{{AFX_DATA(CLCoDlg)
	enum { IDD = IDD_LCO_DIALOG };
		// : ̈ʒu ClassWizard ɂăf[^ oǉ܂B
	//}}AFX_DATA

	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CLCoDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CLCoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnAppAbout();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnEditRename();
	afx_msg void OnEditNewpart();
	afx_msg void OnEditNewalias();
	afx_msg void OnEditClear();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPinInsert();
	afx_msg void OnPinDelete();
	afx_msg void OnEditAttribute();
	afx_msg void OnPtned();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnRadioNullpin();
	afx_msg void OnRadioNormpin();
	afx_msg void OnRadioCkpin();
	afx_msg void OnRadioNegpin();
	afx_msg void OnRadioNegckpin();
	afx_msg void OnRadioSpin();
	//}}AFX_MSG
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSelChangeColList();
	afx_msg void OnSelChangePartView();
	afx_msg void OnMoveItemColList();
	afx_msg void OnInitMenu( CMenu* pMenu );


	DECLARE_MESSAGE_MAP()

protected:
	CSize	m_sizeFrameMin;
	CSize	m_sizeClient;
	BOOL	m_bCloseFlag;
	CString	m_astrPinNum[256];
	CPartView m_wndPartView;

	//CLCoPartInfo*	m_pActivePartInfo;
	//	CLCoPin*		m_pActivePin;
protected:
	void SetItemSize();
	void SetDataPath(LPCSTR pszPathName);
	void SetTitleBar();
	BOOL DoSaveAs();
	BOOL DoSave();
	BOOL DoOpen(LPCSTR pszFileName=NULL);
	BOOL DoSaveChanged();
	void SetAliasColor(int nSelIndex);
	void EnableMenuItem(CMenu* pMenu );
	void DisablePinEditItem(BOOL bNullPin);	//sҏW_CAOACẽCl[uݒ

	void SetNullPinCheck(BOOL bNullPin);	//Nulls̃WI{^ݒ
	BOOL GetNullPinCheck();					//Nulls̃WI{^̏ԂԂ
	int  GetPinTypeRadio();
	void SetPinTypeRadio(int nPinType);

	void SetBlockCtrl();					//ubN_CAOACe̐ݒ
	CLCoPin* GetPinInfo(int nLTRB,int nOffset);	//m_wndPartView̕i̎ws̏𓾂
	void LoadPinInfo(CLCoPin* pPin);//ws̏CLCoDlg̃_CAOACeEϐɃ[h
	
	char* m_pTextBuff;
	int   m_nTextBuffOffset;
	int  AddToTextBuff(LPCSTR sz);
	void Copy();
	void Paste();
	void Clear();

public:
	CColList m_wndColList;
	CLCoData m_LCoData;
};

class SLCoFileSaveDlg  : public CFileDialog
{
public:
	SLCoFileSaveDlg(	BOOL bOpenFileDialog, LPCTSTR lpszDefExt = NULL, 
						LPCTSTR lpszFileName = NULL, DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
						LPCTSTR lpszFilter = NULL, CWnd* pParentWnd = NULL );
	

	void OnTypeChange();

};
