// Place.cpp : CBSchView NX̂}ʗvf̔zu̒`s܂B

#include "stdafx.h"
#include "BSch.h"

#include "SetLib.h"
#include "TagAtrb.h"
#include "CmntAtrb.h"
#include "LblAtrb.h"


#include "BSchObj.h"
#include "BSchJunc.h"
#include "BSchEntr.h"
#include "BSchLine.h"
#include "BSchWire.h"
#include "BSchBus.h"
#include "BSchDash.h"
#include "BSchTag.h"
#include "BSchLbl.h"
#include "BSchCmnt.h"



#include "BSchDoc.h"
#include "BSchView.h"

#include "PartLib.h"
#include "BSchFont.h"
#include "Global.h"

#include "BSchPart.h"
#include "Preview.h"
#include "SelPart.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//WNV̔zu
//W m_pointOcccasional
BOOL CBSchView::PlaceJunction(CDC* pDC,CBSchDoc* pDoc)
{
	CBSchJunc* pObj=new CBSchJunc;
	if(!pObj) return FALSE;
	pObj->SetPoint(&m_pointOccasional);		//W̐ݒ
	pObj->SetLayer(pDoc->m_nEditLayer);

	pDoc->AddData(pObj);					//ꎞf[^ɂ
	pDoc->RemoveSelection();				//ꎞf[^tBbNX
	pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	return TRUE;
}

//Gg[̔zu
//W m_pointOcccasional
//ނ m_nCurrentTool
BOOL CBSchView::PlaceEntry(CDC* pDC,CBSchDoc* pDoc)
{
	CBSchEntry* pObj=new CBSchEntry;
	if(!pObj) return FALSE;
	pObj->SetPoint(&m_pointOccasional);		//W̐ݒ
	int nType;
	switch(m_nCurrentTool){
	case ID_TOOL_ENTRY_BL:nType=ENTRY_BL;break;
	case ID_TOOL_ENTRY_BR:nType=ENTRY_BR;break;
	case ID_TOOL_ENTRY_WL:nType=ENTRY_WL;break;
	case ID_TOOL_ENTRY_WR:nType=ENTRY_WR;break;
	}
	pObj->SetType(nType);
	pObj->SetLayer(pDoc->m_nEditLayer);

	pDoc->AddData(pObj);		//ꎞf[^ɂ
	pDoc->RemoveSelection();	//ꎞf[^tBbNX
	pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	return TRUE;
}


//^O̔zu
//PDAgr[g̃_CAOŕƘg߂
//QDo^
//
//LZ{^ꍇ̓
//      uPɃ_CAOvuZN^c[ɖ߂vɕύX 1997/01/06
BOOL CBSchView::PlaceTag(CDC* pDC,CBSchDoc* pDoc,CPoint* ppoint)
{
	CTagAtrb dlg;
	dlg.m_rName.Empty();
	dlg.m_nType=0;
	if(dlg.DoModal()==IDCANCEL){
		PostMessage(WM_COMMAND,ID_TOOL_SELECTOR,0); //ZN^c[Ɉڍs郁bZ[W
		return TRUE;
	}

	CBSchTag* pObj=new CBSchTag;
	pObj->SetType(dlg.m_nType);
	pObj->SetTagString(dlg.m_rName);
	pObj->SetLayer(pDoc->m_nEditLayer);

	CPoint point=*ppoint;
	SnapToGrid(&point);			//Obhւ̃Xibv
	pObj->SetPoint(&point);		//W̐ݒ
	pObj->Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt);	//XORɂ`
	m_bDrawTmpData=TRUE;						//ꎞf[^`悵Ƃɂ
	pDoc->AddData(pObj);		//ꎞf[^ɂ
	pDoc->SetTmpDirty();		//ĂȂƏIɕۑ𕷂ėȂƂ
//	DrawTmpData(pDC,pDoc,DRAW_XOR,TRUE);	//XORɂ`
	DrawTmpDataFrame(pDC,pDoc,TRUE);		//ꎞf[^̘g̕`
	return TRUE;
}

//x̔zu
//PDAgr[g̃_CAOŕ߂
//QDo^
//
//LZ{^ꍇ̓
//      uPɃ_CAOvuZN^c[ɖ߂vɕύX 1997/01/06
BOOL CBSchView::PlaceLabel(CDC* pDC,CBSchDoc* pDoc,CPoint* ppoint)
{
	CLblAtrb dlg;
	dlg.m_rText.Empty();
	if(dlg.DoModal()==IDCANCEL){
		PostMessage(WM_COMMAND,ID_TOOL_SELECTOR,0); //ZN^c[Ɉڍs郁bZ[W
		return TRUE;
	}
	if(dlg.m_rText.IsEmpty()) return TRUE;
	CBSchLabel* pObj=new CBSchLabel;
	pObj->SetString(dlg.m_rText);
	pObj->SetLayer(pDoc->m_nEditLayer);
	CPoint point=*ppoint;
	SnapToGrid(&point);			//Obhւ̃Xibv
	pObj->SetPoint(&point);		//W̐ݒ
	pObj->Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt);	//XORɂ`
	m_bDrawTmpData=TRUE;						//ꎞf[^`悵Ƃɂ
	pDoc->AddData(pObj);		//ꎞf[^ɂ
	pDoc->SetTmpDirty();		//ĂȂƏIɕۑ𕷂ėȂƂ
//	DrawTmpData(pDC,pDoc,DRAW_XOR,TRUE);	//XORɂ`
	DrawTmpDataFrame(pDC,pDoc,TRUE);		//ꎞf[^̘g̕`
	return TRUE;
}



//Rg̔zu
//PDAgr[g̃_CAOŕƕ̎ނ߂
//QDo^
//
//LZ{^ꍇ̓
//      uPɃ_CAOvuZN^c[ɖ߂vɕύX 1997/01/06
BOOL CBSchView::PlaceComment(CDC* pDC,CBSchDoc* pDoc,CPoint* ppoint)
{
	int n;
	CCmntAtrb dlg;
	dlg.m_rText.Empty();
	dlg.m_bUseSmallFont=FALSE;
	if(dlg.DoModal()==IDCANCEL){
		PostMessage(WM_COMMAND,ID_TOOL_SELECTOR,0); //ZN^c[Ɉڍs郁bZ[W
		return TRUE;
	}
	if(dlg.m_rText.IsEmpty()) return TRUE;
	if(dlg.m_bUseSmallFont) n=COMMENT_SMALL;
	else					n=COMMENT_LARGE;
	CBSchComment* pObj=new CBSchComment;
	pObj->SetType(n);
	pObj->SetString(dlg.m_rText);
	pObj->SetLayer(pDoc->m_nEditLayer);
	CPoint point=*ppoint;
	SnapToGrid(&point);			//Obhւ̃Xibv
	pObj->SetPoint(&point);		//W̐ݒ
	pObj->Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt); //XORɂ`
	m_bDrawTmpData=TRUE;		//ꎞf[^`悵Ƃɂ
	pDoc->AddData(pObj);		//ꎞf[^ɂ
	pDoc->SetTmpDirty();		//ĂȂƏIɕۑ𕷂ėȂƂ
	//	DrawTmpData(pDC,pDoc,DRAW_XOR,TRUE);	//XORɂ`
	DrawTmpDataFrame(pDC,pDoc,TRUE);		//ꎞf[^̘g̕`
	return TRUE;
}



//i̔zu
//PDiĨ_CAOŕi̖O𓾂
//QDi̖O畔iCfbNXւ̃|C^𓾂
//RDiNXmۂ
//SDo^
//
//LZ{^ꍇ̓
//      uPɃ_CAOvuZN^c[ɖ߂vɕύX 1997/01/06
BOOL CBSchView::PlacePart(CDC* pDC,CBSchDoc* pDoc,CPoint* ppoint)
{
	CSelPart dlg;
	dlg.m_bUsePreview=g_bUsePreview;	//vr[gǂ̐ݒ
//	dlg.m_nLastSelectPart=m_nLastSelectPart;
//
//  CPartLib.m_nLastSelectLibraryV݂ł̂荬CBKv
//					1997/01/28
	if(g_pPartLib[m_nLastSelectLibrary]){//NULLłȂ...
//		dlg.m_nLastSelectPart=g_pPartLib[m_nLastSelectLibrary]->m_nLastSelectIndex;
		dlg.m_nLastSelectLibrary=m_nLastSelectLibrary;
	}else{
//		dlg.m_nLastSelectPart=0;
		dlg.m_nLastSelectLibrary=0;
	}
	if(dlg.DoModal()==IDCANCEL){
		PostMessage(WM_COMMAND,ID_TOOL_SELECTOR,0); //ZN^c[Ɉڍs郁bZ[W
		return TRUE;
	}
	int nLib;
	int nPart;
	CPartIndex* pPartIndex = g_SearchPartIndex(dlg.m_rStrPartName,&nLib,&nPart);
	if(pPartIndex==NULL){
		CString rString;
		//bZ[W{bNXp̃bZ[W̍쐬
		AfxFormatString1(rString,IDS_NOT_FOUND_PART,dlg.m_rStrPartName); 
		AfxMessageBox(rString,MB_OK|MB_ICONEXCLAMATION);
		return TRUE;
	}
//	m_nLastSelectPart=nPart;
	m_nLastSelectLibrary=nLib;
	g_pPartLib[nLib]->m_nLastSelectIndex=nPart;
	

	CBSchPart* pObj=new CBSchPart;
	if(!pObj) return FALSE;
	pObj->SetPartIndex(pPartIndex);
	//W̌
	//PD(0,0)ɉzuĂ GetPointLT()ōW𓾂
	//QDzuԂEɂ炷
	CPoint point=CPoint(0,0);	//(0,0)ɉzu
	pObj->SetLayer(pDoc->m_nEditLayer);

	pObj->SetPoint(&point);		//W̐ݒ
	point=pObj->GetPointLT();	//W𓾂
	SnapToGrid(ppoint);			//Obhւ̃Xibv
	point.x=ppoint->x - point.x;//Eւ炷
	point.y=ppoint->y - point.y;
	pObj->SetPoint(&point);		//W̐ݒ

	pObj->Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt); //XORɂ`
	m_bDrawTmpData=TRUE;		//ꎞf[^`悵Ƃɂ

	
	pDoc->AddData(pObj);		//ꎞf[^ɂ
	pDoc->SetTmpDirty();		//ĂȂƏIɕۑ𕷂ėȂƂ
//	DrawTmpData(pDC,pDoc,DRAW_XOR,TRUE);	//XORɂ`
	DrawTmpDataFrame(pDC,pDoc,TRUE);		//ꎞf[^̘g̕`
	return TRUE;
}



//C[̔zu
//zuẂAm_bMoveFrom,m_bMoveTo,m_bWireHorizon1st vZ
BOOL CBSchView::PlaceWire(CDC* pDC,CBSchDoc* pDoc)
{
	CPoint point;
	if(m_bWireHorizon1st){		//ɐ
		point.x=m_ptMoveTo.x;
		point.y=m_ptMoveFrom.y;
	}else{
		point.x=m_ptMoveFrom.x;
		point.y=m_ptMoveTo.y;
	}
	CBSchWire* pObj;
	//P{ڂ̃C[IuWFNg̍쐬Ɠo^
	if(m_ptMoveFrom!=point){
		pObj=new CBSchWire;
		if(!pObj) return FALSE;
		pObj->SetPoint(&m_ptMoveFrom);
		pObj->SetPoint1(&point);
		pObj->SetLayer(pDoc->m_nEditLayer);
		pDoc->AddData(pObj);
		pDoc->SetTmpDirty();
		pDoc->RemoveSelection();	//ꎞf[^tBbNX
		pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	}
	//Q{ڂ̃C[IuWFNg̍쐬Ɠo^
	if(point!=m_ptMoveTo){
		pObj=new CBSchWire;
		if(!pObj) return FALSE;
		pObj->SetPoint(&point);
		pObj->SetPoint1(&m_ptMoveTo);
		pObj->SetLayer(pDoc->m_nEditLayer);
		pDoc->AddData(pObj);
		pDoc->SetTmpDirty();
		pDoc->RemoveSelection();	//ꎞf[^tBbNX
		pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	}
	return TRUE;
}	

//oX̔zu
//zuẂAm_bMoveFrom,m_bMoveTo,m_bWireHorizon1st vZ
BOOL CBSchView::PlaceBus(CDC* pDC,CBSchDoc* pDoc)
{
	CPoint point;
	if(m_bWireHorizon1st){		//ɐ
		point.x=m_ptMoveTo.x;
		point.y=m_ptMoveFrom.y;
	}else{
		point.x=m_ptMoveFrom.x;
		point.y=m_ptMoveTo.y;
	}
	CBSchBus* pObj;
	//P{ڂ̃C[IuWFNg̍쐬Ɠo^
	if(m_ptMoveFrom!=point){
		pObj=new CBSchBus;
		if(!pObj) return FALSE;
		pObj->SetPoint(&m_ptMoveFrom);
		pObj->SetPoint1(&point);
		pObj->SetLayer(pDoc->m_nEditLayer);
		pDoc->AddData(pObj);
		pDoc->SetTmpDirty();
		pDoc->RemoveSelection();	//ꎞf[^tBbNX
		pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	}
	//Q{ڂ̃C[IuWFNg̍쐬Ɠo^
	if(point!=m_ptMoveTo){
		pObj=new CBSchBus;
		if(!pObj) return FALSE;
		pObj->SetPoint(&point);
		pObj->SetPoint1(&m_ptMoveTo);
		pObj->SetLayer(pDoc->m_nEditLayer);

		pDoc->AddData(pObj);
		pDoc->SetTmpDirty();
		pDoc->RemoveSelection();	//ꎞf[^tBbNX
		pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	}
	return TRUE;
}	

//j̔zu
//zuẂAm_bMoveFrom,m_bMoveTo
BOOL CBSchView::PlaceDash(CDC* pDC,CBSchDoc* pDoc)
{
	CBSchDash* pObj;
	//P{ڂ̃C[IuWFNg̍쐬Ɠo^
	if(m_ptMoveFrom!=m_ptMoveTo){
		pObj=new CBSchDash;
		if(!pObj) return FALSE;
		pObj->SetPoint(&m_ptMoveFrom);
		pObj->SetPoint1(&m_ptMoveTo);
		pObj->SetLayer(pDoc->m_nEditLayer);
		pDoc->AddData(pObj);
		pDoc->SetTmpDirty();
		pDoc->RemoveSelection();	//ꎞf[^tBbNX
		pObj->Draw(pDC,DRAW_ON,m_nVExt,m_nWExt);
	}
	return TRUE;
}

