// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "BSch.h"
#include "global.h"
#include "SetLib.h"
#include "BSchFont.h"
#include "Client.h"

#include "MainFrm.h"
#include "Splash.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_VIEW_STATUS_BAR, OnUpdateViewStatusBar)
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	ON_COMMAND(ID_VIEW_TOOLBAR, OnViewToolbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR, OnUpdateViewToolbar)
	ON_COMMAND(ID_USE_PREVIEW, OnUsePreview)
	ON_UPDATE_COMMAND_UI(ID_USE_PREVIEW, OnUpdateUsePreview)
	ON_UPDATE_COMMAND_UI(ID_SNAP_GRID, OnUpdateSnapGrid)
	ON_COMMAND(ID_SNAP_GRID, OnSnapGrid)
	ON_COMMAND(ID_SET_LIBRARY, OnSetLibrary)
	ON_COMMAND(ID_SET_COMMENT_FONT, OnSetCommentFont)
	ON_COMMAND(ID_HELP, OnHelp)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // 0 Xe[^X C CWP[^
//	ID_INDICATOR_KANA,		// 폜
	ID_INDICATOR_CAPS,		// 1
	ID_INDICATOR_NUM,		// 2
//	ID_INDICATOR_SCRL,
    ID_SEPARATOR,			// 3   XŴ߂̒ǉ
    ID_SEPARATOR,			// 4   YŴ߂̒ǉ
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
//	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
//		return -1;
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	DWORD dwVisible;

	//c[o[̕\E\̏WXg瓾 1997/01/25
	if(AfxGetApp()->GetProfileInt("Option","DisplayToolBar",TRUE)) dwVisible=WS_VISIBLE;
	else dwVisible=0;
	if (!m_wndToolBar.Create(this,WS_CHILD|dwVisible|CBRS_TOP) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	//Xe[^Xo[̕\E\̏WXg瓾 1997/01/25
	if(AfxGetApp()->GetProfileInt("Option","DisplayStatusBar",TRUE)) dwVisible=WS_VISIBLE;
	else dwVisible=0;
	if (!m_wndStatusBar.Create(	this,
								WS_CHILD|dwVisible|CBRS_BOTTOM,
								ID_BSCH_STATUS_BAR) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	//Xe[^Xo[̍W\g̊m
	int nStusBarWidth;	//Xe[^Xo[ɍW\邽߂̕
	TEXTMETRIC tm;	//eLXggbN
	CDC* pDC=m_wndStatusBar.GetDC();
	pDC->GetTextMetrics(&tm);
	m_wndStatusBar.ReleaseDC(pDC);
	nStusBarWidth=tm.tmAveCharWidth*(4+1);	//͂S{}[W1
	m_wndStatusBar.SetPaneInfo(3,ID_SEPARATOR,SBPS_NORMAL,nStusBarWidth);
	m_wndStatusBar.SetPaneInfo(4,ID_SEPARATOR,SBPS_NORMAL,nStusBarWidth);


	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);


	m_clientwnd.SubclassWindow(m_hWndMDIClient);

	// CG: ̍śuXvbV XN[vR|[lgɂǉĂ܂B
	CSplashWnd::ShowSplashScreen(this);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB
	/////////////////////////////////////////////////////////////////////////////
	// 1996/10/31
	//TCYύXɍĕ`sȂ悤ɂ邽߂ɁAݒ肷B
	//ftHgł́ACS_HREDRAW|CS_VREDRAW LɂȂĂ邽߁Aĕ`sB
	//
	//TCYMDIwiĕ`悷邽߂ɁACS_HREDRAW|CS_VREDRAW Lɂ 1998/11/10
	//ς胊TCYɂ炿炷̂邳̂CS_HREDRAW|CS_VREDRAW 𖳌 1999/10/16
	if(cs.lpszClass==NULL){
		LPCSTR lpszClassName=AfxRegisterWndClass(	//EBhENX̐VK쐬
			CS_DBLCLKS , //CS_HREDRAW | CS_VREDRAW, 
			AfxGetApp()->LoadStandardCursor(IDC_ARROW),	
			(HBRUSH)GetStockObject(BLACK_BRUSH),	//wi͍
			AfxGetApp()->LoadIcon(IDR_MAINFRAME));	//AvP[VWACR
		cs.lpszClass=lpszClassName;
	}

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG




/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh



////////////////////////////////////////////////////////////
// Xe[^Xo[̕\^\؂ւ
// AppWizardXe[^Xo[BSchƎID̂ɒu
// ̃nhKvɂȂB
// Ql Inside Visual C++ VERSION 4(AXL[j13
void CMainFrame::OnUpdateViewStatusBar(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->SetCheck((m_wndStatusBar.GetStyle()&WS_VISIBLE)!=0);	
}

void CMainFrame::OnViewStatusBar() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	//Xe[^Xo[̕\E\WXgɕۑ 1997/01/25
	BOOL bDisplay=((m_wndStatusBar.GetStyle()&WS_VISIBLE)==0);
	AfxGetApp()->WriteProfileInt("Option","DisplayStatusBar",bDisplay);
	CMDIFrameWnd::OnBarCheck(ID_BSCH_STATUS_BAR);	//1997/04/11 ǉ
	//m_wndStatusBar.ShowWindow(bDisplay);		//1997/04/11 폜
	//RecalcLayout();							//1997/04/11 폜
}

//ppoint̒lXe[^Xo[ɕ\
void CMainFrame::SetStatusBarXY(const POINT* ppoint)
{
	char str[32];
	wsprintf(str,"%5d",ppoint->x);
	m_wndStatusBar.SetPaneText(3,str);
	wsprintf(str,"%5d",ppoint->y);
	m_wndStatusBar.SetPaneText(4,str);
}



void CMainFrame::OnViewToolbar() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	BOOL bDisplay=((m_wndToolBar.GetStyle()&WS_VISIBLE)==0);
	AfxGetApp()->WriteProfileInt("Option","DisplayToolBar",bDisplay);
	OnBarCheck(AFX_IDW_TOOLBAR);	//1997/04/11 ǉ
//	CFrameWnd::OnBarCheck(AFX_IDW_TOOLBAR);	//1997/04/11 ǉ
	//m_wndToolBar.ShowWindow(bDisplay);	//1997/04/11 폜
	//RecalcLayout();						//1997/04/11 폜
}

void CMainFrame::OnUpdateViewToolbar(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->SetCheck((m_wndToolBar.GetStyle()&WS_VISIBLE)!=0);	
}


void CMainFrame::OnUsePreview() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	g_bUsePreview=(g_bUsePreview==FALSE);
	g_IniWriteUsePreview(g_bUsePreview);

}

void CMainFrame::OnUpdateUsePreview(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->SetCheck(g_bUsePreview);
}

void CMainFrame::OnUpdateSnapGrid(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->SetCheck(g_bSnaptoGrid);
}

void CMainFrame::OnSnapGrid() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	g_bSnaptoGrid=(g_bSnaptoGrid==FALSE);
}

void CMainFrame::OnSetLibrary() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CSetLib dlg;
	if(dlg.DoModal()==IDOK){
		AfxMessageBox(
			IDS_LIBSET_VALID_NEXT,
			MB_OK|MB_ICONEXCLAMATION);
	}
}

void CMainFrame::OnSetCommentFont() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	LOGFONT lfInit;
	g_IniReadFontInfo(&lfInit);		//WXgtHg𓾂
	CFontDialog dlg(&lfInit,CF_SCREENFONTS);
	if(dlg.DoModal()==IDOK){
		g_IniWriteFontInfo(&lfInit);	//WXgɃtHg
		AfxMessageBox(IDS_SETFONT_VALIDNEXT);
	}
}

void CMainFrame::OnHelp() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	AfxGetApp()->WinHelp(0,HELP_INDEX);
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIFrameWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_clientwnd.Invalidate();

}
