////////////////////////////////////////////////////////////////////
//    PARTINFO.H  
//

#define PIN_TYPE_SMALL		0x00000001
#define PIN_TYPE_CLOCK		0x00000004
#define PIN_TYPE_NEGATIVE	0x00000008

#define PIN_LOC_L			0x0000
#define PIN_LOC_T			0x0001
#define PIN_LOC_R			0x0002
#define PIN_LOC_B			0x0003

#define BITLTRB_L	1
#define BITLTRB_T	2
#define BITLTRB_R	4
#define BITLTRB_B	8

////////////////////////////////////////////////////////////////////
//sNX̒`
class CLCoPin
{
public:
	CString	m_strName;			//s
	int		m_nType;			//s̃^Cv
	int		m_nLTRB;			//LTRBP[V
	int		m_nOffset;			//ʒuItZbg
	CString*	m_pstrPinNum;	//sԍzւ̃|C^

	CLCoPin(){					//RXgN^
		m_nType		=0;
		m_nLTRB		=0;
		m_nOffset	=0;
		m_pstrPinNum	=NULL;
	}

	virtual ~CLCoPin(){					//fXgN^
		delete[]m_pstrPinNum;
	}
};

////////////////////////////////////////////////////////////////////
//p^[NX̒`
class CLCoPtn
{
public:
	CString		m_strName;	//p^[
	CSize		m_size;		//TCY
	BYTE*		m_pBuff;	//obt@ւ̃|C^

	CLCoPtn(){			//RXgN^
		m_size=CSize(21,21);
		m_pBuff=NULL;
	}

	virtual ~CLCoPtn(){			//fXgN^
		delete[]m_pBuff;
	}
};
	
//p^[̓er
//O͊֒mȂ
//evAOԂBsvȂAPԂ
int g_PtnCmp(const CLCoPtn* pPtn1,const CLCoPtn* pPtn2);



////////////////////////////////////////////////////////////////////
//iNX̒`
class CLCoPartInfo 
{
public:
	CString		m_strPrefix;	//iԍ
	CSize		m_size;			//ĩTCY
	int			m_nBlock;		//pbP[W̃ubN
	CLCoPtn*	m_pPtn;			//p^[ւ̃|C^
	CTypedPtrList<CPtrList, CLCoPin*> m_listPin;	//s̃Xg
	CLCoPartInfo();				//RXgN^
	virtual ~CLCoPartInfo();	//fXgN^
	void ChangeBlock(int nNewBlock);	//`ςݕĩubNύX
};

////////////////////////////////////////////////////////////////////
//iCfbNXNX̒`
class CLCoPartIndex
{
public:
	CString			m_strName;		//i
	CLCoPartInfo*	m_pPartInfo;	//Ή镔iNXւ̃|C^

	CLCoPartIndex(){m_pPartInfo=NULL;}
};


